﻿Imports System.Threading
Imports System.Configuration

Public Class Form1

Private WithEvents CtxMenu As New ContextMenuStrip
Private MnuText As New ToolStripMenuItem
Private MnuDate As New ToolStripMenuItem
Private MnuDateTimeMin As New ToolStripMenuItem
Private MnuDateTimeSec As New ToolStripMenuItem
Private MnuGotD As New ToolStripMenuItem

Private Const WinV As Integer = 101

Private ActiveWindowHandle As IntPtr = 0, ActiveControlHandle As IntPtr
Dim SelStart As Integer, SelEnd As Integer

Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  With CtxMenu.Items
    .Add(MnuText)
    .Add(New ToolStripSeparator())
    .Add(MnuDate)
    .Add(MnuDateTimeMin)
    .Add(MnuDateTimeSec)
    .Add(MnuGotD)
    .Add(New ToolStripSeparator())

    For Q As Integer = 1 To Val(ConfigurationManager.AppSettings("Items.Count"))
      Dim Text As String = ConfigurationManager.AppSettings("Items." & Q)
      If String.IsNullOrEmpty(Text) Then
        .Add(New ToolStripSeparator())
      Else
        .Add(Text)
      End If
    Next Q
  End With

  For Each Item As ToolStripItem In CtxMenu.Items
    Dim Mnu As ToolStripMenuItem = TryCast(Item, ToolStripMenuItem)

    If Mnu IsNot Nothing Then AddHandler Mnu.Click, AddressOf Mnu_Click
  Next Item

  RegisterHotKey(Me.Handle, WinV, Modifiers.Win, Keys.V)

  Call (New Thread(Sub()
                     Do
                       Thread.Sleep(10)
                     Loop Until Me.Invoke(Function() Me.Visible)
                     Me.Invoke(Sub() Me.Visible = False)
                   End Sub)).Start()
End Sub

Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
  UnregisterHotKey(Me.Handle, WinV)
End Sub

Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
  If m.Msg = WinMsgs.WmHotkey Then
    Select Case m.WParam
      Case WinV
        WinV_Pressed()
    End Select
  End If

  MyBase.WndProc(m)
End Sub

Private Sub WinV_Pressed()
  Dim MyPrcId As IntPtr, OtherPrcId As IntPtr
  Dim Pos As PointApi

  ActiveWindowHandle = GetForegroundWindow()

  MyPrcId = GetCurrentThreadId()
  OtherPrcId = GetWindowThreadProcessId(ActiveWindowHandle, OtherPrcId)

  AttachThreadInput(OtherPrcId, MyPrcId, 1)

  ActiveControlHandle = GetFocus()
  SendMessageRR(ActiveControlHandle, WinMsgs.EmGetsel, SelStart, SelEnd)
  GetCaretPos(Pos)
  ClientToScreen(ActiveControlHandle, Pos)

  AttachThreadInput(OtherPrcId, MyPrcId, 0)

  CtxMenu.Show(Pos.X, Pos.Y)
  SetForegroundWindow(CtxMenu.Handle)
End Sub

Private Sub CtxMenu_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles CtxMenu.Opening
  Dim Text As String = Clipboard.GetText()
  Dim CurDate As Date = Now

  MnuText.Text = If(String.IsNullOrEmpty(Text), "", Wrap(Text))

  MnuDate.Text = CurDate.ToString("yyyy_MM_dd")
  MnuDateTimeMin.Text = CurDate.ToString("yyyy_MM_dd HH_mm")
  MnuDateTimeSec.Text = CurDate.ToString("yyyy_MM_dd HH_mm_ss")
  MnuGotD.Text = "^C{HOME}" & CurDate.AddHours(-11).ToString("yyyy_MM_dd") & " ^V{\}{ENTER}{END 8}{ENTER}{END 8}{F7}{~} Temp{ENTER}"
End Sub

Private Sub Mnu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
  Dim Text As String = CType(sender, ToolStripMenuItem).Text

  SetForegroundWindow(ActiveWindowHandle)
  Thread.Sleep(64)
  SendMessageVV(ActiveControlHandle, WinMsgs.EmSetsel, SelStart, SelEnd)
  Thread.Sleep(64)
  SendKeys.SendWait(Text)
End Sub

End Class
